import numpy as np
from matplotlib import pyplot as plt
from PIL import Image
import sys

sys.path.insert(0, '../../algorithms/distance/')

from rmsdiff import rmsdiff

sys.path.insert(0, '../../algorithms/context_adaptive_interpolator/')

from context_adaptive_interpolator import contextAdaptiveInterpolator

IMAGE_SIZE = 64

def randomImage(scale):
    return np.maximum(np.random.normal(loc = 0, scale = scale, size = (IMAGE_SIZE, IMAGE_SIZE)), 0)

prnu = randomImage(scale = 1)

images = [randomImage(scale = 10) + prnu for _ in range(10)]
allImages = [prnu] + images

def toPilImage(npArray):
    npArray = np.round(255 * npArray / np.max(allImages))
    return Image.fromarray(np.uint8(npArray))

prnu = toPilImage(prnu)
#prnu.show()

images = [toPilImage(image) for image in images]
#images[0].show()

for image in images:
    initialRmsDiff = rmsdiff(image, prnu)
    caiRmsDiff = rmsdiff(contextAdaptiveInterpolator(image.load(), image), prnu)
    print(f'{initialRmsDiff=} {caiRmsDiff=}')